Update a schedule
curl --request PATCH \
--url https://api.shiftkeeper.io/schedules/{schedule_id} \
--header 'Content-Type: application/json' \
--header 'x-api-key: <api-key>' \
--data '
{
"name": "<string>",
"description": "<string>",
"layers": [
{
"name": "<string>",
"rotation_start": "2023-11-07T05:31:56Z",
"concurrent_oncall_users": 2,
"user_references": [
{
"type": "email",
"value": "emma@example.org"
}
],
"shift_length": {
"amount": 2
},
"restriction_intervals": [
{
"from": "<string>",
"to": "<string>"
}
]
}
],
"team_ids": [
"<string>"
]
}
'import requests
url = "https://api.shiftkeeper.io/schedules/{schedule_id}"
payload = {
"name": "<string>",
"description": "<string>",
"layers": [
{
"name": "<string>",
"rotation_start": "2023-11-07T05:31:56Z",
"concurrent_oncall_users": 2,
"user_references": [
{
"type": "email",
"value": "emma@example.org"
}
],
"shift_length": { "amount": 2 },
"restriction_intervals": [
{
"from": "<string>",
"to": "<string>"
}
]
}
],
"team_ids": ["<string>"]
}
headers = {
"x-api-key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.patch(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PATCH',
headers: {'x-api-key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: '<string>',
description: '<string>',
layers: [
{
name: '<string>',
rotation_start: '2023-11-07T05:31:56Z',
concurrent_oncall_users: 2,
user_references: [{type: 'email', value: 'emma@example.org'}],
shift_length: {amount: 2},
restriction_intervals: [{from: '<string>', to: '<string>'}]
}
],
team_ids: ['<string>']
})
};
fetch('https://api.shiftkeeper.io/schedules/{schedule_id}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"schedule": {
"name": "<string>",
"time_zone": "<string>",
"layers": [
{
"name": "<string>",
"rotation_start": "2023-11-07T05:31:56Z",
"concurrent_oncall_users": 2,
"users": [
{
"id": "<string>",
"name": "<string>",
"email": "jsmith@example.com",
"time_zone": "<string>",
"slack_id": "<string>"
}
],
"shift_length": {
"amount": 2
},
"restriction_intervals": [
{
"from": "<string>",
"to": "<string>"
}
]
}
],
"teams": [
{
"id": "<string>",
"name": "<string>",
"description": "<string>"
}
],
"current_revision": 1,
"current_revision_valid_from": "2023-11-07T05:31:56Z",
"users": [
{
"id": "<string>",
"name": "<string>",
"email": "jsmith@example.com",
"time_zone": "<string>",
"slack_id": "<string>"
}
],
"description": "<string>",
"current_oncall_shift": {
"users": [
{
"id": "<string>",
"name": "<string>",
"email": "jsmith@example.com",
"time_zone": "<string>",
"slack_id": "<string>"
}
],
"start": "2023-11-07T05:31:56Z",
"end": "2023-11-07T05:31:56Z"
},
"next_oncall_shift": {
"users": [
{
"id": "<string>",
"name": "<string>",
"email": "jsmith@example.com",
"time_zone": "<string>",
"slack_id": "<string>"
}
],
"start": "2023-11-07T05:31:56Z",
"end": "2023-11-07T05:31:56Z"
}
}
}{
"error": {
"code": "not_found",
"status": 404,
"message": "The requested resource was not found"
}
}{
"error": {
"code": "duplicate_schedule_name",
"message": "A schedule with this name already exists",
"status": 422,
"docs_url": "https://docs.shiftkeeper.io/api-reference/errors#duplicate-schedule-name"
}
}Schedules
Update a schedule
Update a schedule. Changes to the schedule rotation settings do not affect shifts which have already finished.
PATCH
/
schedules
/
{schedule_id}
Update a schedule
Authorizations
Enter your API key which starts with 'keeper_'
Path Parameters
The ID of the schedule.
Body
application/json
The name of the schedule.
Required string length:
1 - 60The description of the schedule.
Maximum string length:
200The layers of the schedule. Currently, schedules can have only one layer.
Required array length:
1 elementShow child attributes
Show child attributes
The teams to link to the schedule.
Maximum array length:
10Response
Default Response
Show child attributes
Show child attributes
Example:
{
"name": "Incident responders",
"description": "Incident responders",
"time_zone": "Europe/Berlin",
"layers": [
{
"name": "Main",
"rotation_start": "2024-01-01T00:00:00Z",
"concurrent_oncall_users": 1,
"users": [
{
"id": "usr_bq7CmsOKLmkMeZkUUu1hy",
"name": "Rick",
"email": "rick@example.org",
"time_zone": "Europe/Paris",
"role": "owner",
"seat": "member",
"slack_id": "U082KENSEQ3"
},
{
"id": "usr_C0GwCFdk0I4pBMRny4qYV",
"name": "Dena",
"email": "dena@example.org",
"role": "standard",
"seat": "member",
"slack_id": "U082GMAFR1T"
},
{
"id": "usr_YlxrjoB1JqUsollScfFYT",
"name": "Lily",
"email": "lily@example.org",
"time_zone": "America/New_York",
"role": "standard",
"seat": "viewer",
"slack_id": "U0529FWNCG2"
}
],
"shift_length": { "amount": 1, "unit": "weeks" },
"restriction_intervals": []
}
],
"current_revision": 1,
"current_revision_valid_from": "2024-12-01T00:00:00Z",
"current_oncall_shift": {
"users": [
{
"id": "usr_bq7CmsOKLmkMeZkUUu1hy",
"name": "Rick",
"email": "rick@example.org",
"time_zone": "Europe/Paris",
"role": "owner",
"seat": "member",
"slack_id": "U082KENSEQ3"
}
],
"start": "2024-01-01T00:00:00Z",
"end": "2024-01-01T01:00:00Z"
},
"next_oncall_shift": {
"users": [
{
"id": "usr_C0GwCFdk0I4pBMRny4qYV",
"name": "Dena",
"email": "dena@example.org",
"role": "standard",
"seat": "member",
"slack_id": "U082GMAFR1T"
}
],
"start": "2024-01-01T01:00:00Z",
"end": "2024-01-01T02:00:00Z"
},
"users": [
{
"id": "usr_bq7CmsOKLmkMeZkUUu1hy",
"name": "Rick",
"email": "rick@example.org",
"time_zone": "Europe/Paris",
"role": "owner",
"seat": "member",
"slack_id": "U082KENSEQ3"
},
{
"id": "usr_C0GwCFdk0I4pBMRny4qYV",
"name": "Dena",
"email": "dena@example.org",
"role": "standard",
"seat": "member",
"slack_id": "U082GMAFR1T"
},
{
"id": "usr_YlxrjoB1JqUsollScfFYT",
"name": "Lily",
"email": "lily@example.org",
"time_zone": "America/New_York",
"role": "standard",
"seat": "viewer",
"slack_id": "U0529FWNCG2"
}
],
"teams": [
{
"id": "tea_VJ4sYEOOXVvJBXqFjRzpm",
"name": "Payments",
"description": "All about payments and billing"
}
]
}
⌘I